SystemOrganization addCategory: #'AL-Rendering'!

!BlockClosure methodsFor: '*al-rendering-converting' stamp: 'cwp 8/6/2011 15:09'!
asCallback
	^ self shallowCopy postCallbackCopy! !

!BlockClosure methodsFor: '*al-rendering-converting' stamp: 'cwp 8/6/2011 15:10'!
postCallbackCopy
	outerContext := outerContext copyForCallback! !

!BlockClosure methodsFor: '*al-rendering-dispatch' stamp: 'cwp 9/19/2011 17:25'!
renderOn: aCanvas
	aCanvas renderBlock: self! !

!MethodContext methodsFor: '*al-rendering-converting' stamp: 'cwp 8/6/2011 15:11'!
copyForCallback
	^ self shallowCopy postCallbackCopy! !

!MethodContext methodsFor: '*al-rendering-converting' stamp: 'cwp 8/6/2011 15:13'!
postCallbackCopy
	sender := nil.
	closureOrNil ifNotNil: [closureOrNil := closureOrNil asCallback].
	! !

Object subclass: #ALBrush
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Rendering'!

!ALBrush class methodsFor: 'as yet unclassified' stamp: 'cwp 3/14/2011 00:57'!
on: aCanvas
	^ self basicNew initializeWithCanvas: aCanvas! !

!ALBrush methodsFor: 'initialize-release' stamp: 'cwp 7/19/2011 19:34'!
initializeWithCanvas: aCanvas
	self initialize.
	canvas := aCanvas.
! !

!ALBrush methodsFor: 'rendering' stamp: 'cwp 9/19/2011 17:22'!
with: anObject
	canvas push.
	[canvas render: anObject] ensure:
		[canvas close.
		canvas pop]! !

!ALBrush methodsFor: 'writing' stamp: 'cwp 8/11/2012 10:32'!
writeCloseInto: aWriteStream escaping: anObject
	self subclassResponsibility ! !

!ALBrush methodsFor: 'writing' stamp: 'cwp 8/11/2012 10:32'!
writeEmptyInto: aWriteStream escaping: escWriteStream
	self writeOpenInto: aWriteStream escaping: escWriteStream.
	self writeCloseInto: aWriteStream escaping: escWriteStream! !

!ALBrush methodsFor: 'writing' stamp: 'cwp 8/11/2012 10:28'!
writeOpenInto: aWriteStream escaping: anObject
	self subclassResponsibility ! !

Object subclass: #ALCanvas
	instanceVariableNames: 'stream stack current escaping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Rendering'!

!ALCanvas class methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2011 08:36'!
on: aStream
	^ self basicNew initializeWithStream: aStream! !

!ALCanvas methodsFor: 'stack' stamp: 'cwp 8/11/2012 10:26'!
close
	current ifNotNil: 
		[current writeEmptyInto: stream escaping: escaping. 
		current := nil]! !

!ALCanvas methodsFor: 'stack' stamp: 'cwp 3/14/2011 01:07'!
flush
	self close.
	[stack isEmpty] whileFalse: [self pop]! !

!ALCanvas methodsFor: 'initialize-release' stamp: 'cwp 8/11/2012 10:23'!
initializeEscaping
	escaping := stream! !

!ALCanvas methodsFor: 'initialize-release' stamp: 'cwp 8/11/2012 10:24'!
initializeWithStream: aStream
	self initialize.
	stream := aStream.
	stack := OrderedCollection new.
	current := nil.
	self initializeEscaping.! !

!ALCanvas methodsFor: 'stack' stamp: 'cwp 8/11/2012 10:25'!
open: aTag
	current ifNotNil: [current writeEmptyInto: stream escaping: escaping].
	^ current := aTag
	! !

!ALCanvas methodsFor: 'stack' stamp: 'cwp 8/11/2012 10:32'!
pop
	stack removeLast writeCloseInto: stream escaping: escaping! !

!ALCanvas methodsFor: 'stack' stamp: 'cwp 8/11/2012 10:28'!
push
	current writeOpenInto: stream escaping: escaping.
	stack add: current.
	current := nil! !

!ALCanvas methodsFor: 'rendering' stamp: 'cwp 9/27/2011 22:45'!
raw: aString
	stream write: aString! !

!ALCanvas methodsFor: 'rendering' stamp: 'cwp 9/19/2011 17:20'!
render: anObject
	anObject renderOn: self! !

!ALCanvas methodsFor: 'rendering' stamp: 'cwp 9/19/2011 17:26'!
renderBlock: aBlock
	aBlock cull: self! !

!ALCanvas methodsFor: 'rendering' stamp: 'cwp 9/19/2011 17:23'!
renderString: aString
	self text: aString! !

!ALCanvas methodsFor: 'serializing' stamp: 'cwp 3/6/2012 17:36'!
serializeWith: aSerializer
	aSerializer serialize: nil! !

!ALCanvas methodsFor: 'accessing' stamp: 'cwp 3/6/2012 15:31'!
stream
	^ stream! !

!ALCanvas methodsFor: 'rendering' stamp: 'cwp 9/13/2012 13:45'!
text: aString
	current ifNotNil: 
		[current writeEmptyInto: stream escaping: escaping.
		current := nil].
	escaping write: aString! !

Object subclass: #ALRenderingContext
	instanceVariableNames: 'locator resource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Rendering'!

!ALRenderingContext class methodsFor: 'as yet unclassified' stamp: 'cwp 8/5/2011 22:10'!
resource: aResource locator: aLocator
	^ self basicNew initializeWithResource: aResource locator: aLocator  ! !

!ALRenderingContext methodsFor: 'initialize-release' stamp: 'cwp 8/5/2011 22:11'!
initializeWithResource: aResource locator: aLocator
	self initialize.
	resource := aResource.
	locator := aLocator! !

!ALRenderingContext methodsFor: 'registering' stamp: 'cwp 10/8/2012 00:19'!
registerCallback: aValuable
	| target |
	target := ALCallbackResource resource: resource callback: aValuable asCallback.
	^ locator urlForResource: target.  ! !

!ALRenderingContext methodsFor: 'registering' stamp: 'cwp 9/24/2011 15:44'!
registerForm: aForm
	| rsrc |
	rsrc := ALFormResource resource: resource form: aForm.
	^ self registerResource: rsrc! !

!ALRenderingContext methodsFor: 'registering' stamp: 'cwp 10/8/2012 00:19'!
registerNavigation: aValuable
	| callback |
	callback := ALCallbackResource resource: resource callback: aValuable asCallback.
	^ locator urlForResource: callback rematerialize value.! !

!ALRenderingContext methodsFor: 'registering' stamp: 'cwp 10/8/2012 00:19'!
registerResource: resource
	^ locator urlForResource: resource! !

!String methodsFor: '*al-rendering-dispatch' stamp: 'cwp 9/19/2011 17:23'!
renderOn: aCanvas
	aCanvas renderString: self! !
